/*;  common.cc {\documentstyle[fleqn]{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.1 $$ {\rhead{\sl common.cc\quad\thepage}} */
/*;  $$Date: 2000/12/02 10:04:33 $$  */
/*;  $$Source: /home/shiiba/ohymos-lib/ohymos-current/common.cc,v $$  */
/*;  $$RCShost: yodo.kuciv.kyoto-u.ac.jp $$  */

// @(#) common.cc

#include <stdio.h>

#include "common.h"
#include <stdlib.h>         // exit function
#include <ctype.h>          // isspace function
#include <iostream>       // istream

#include <string.h>             // strcpy, strcat, ...

// #include <strstream.h>      // input stream from a string
#include <sstream>      // input stream from a string

//

using namespace std;

void Print_comments(FILE* fp_out,
                    char* src_file, int src_line, char* head)
{   //    Print_comments  (define)

    // Open the source file
    FILE* src_fp  = fopen(src_file, "r");
    if (src_fp == NULL) {
        char* pathes = getenv(Mysdir);
        if (pathes == NULL) return;
//         istrstream is(pathes);
        istringstream is(pathes);
        const int BUFFLEN = 128; char fname[BUFFLEN];
        for (;;) {
            char path[BUFFLEN];
            is.getline(path, BUFFLEN, ';'); // read a string using \';\'
                                            // as a delimeter
            if (strlen(path) == 0) return;
            strcpy(fname, path);
            strcat(fname, "/");
            strcat(fname, src_file);
            src_fp = fopen(fname, "r");
            if (src_fp != NULL) break;
        }
    }

    int l;      // for counting lines
    char buf;

    // Mobe src_fp to the beginning of the line src_line
    for (l = 1; l < src_line; l++)
        while ((buf = fgetc(src_fp)) != '\n')
            if (buf == EOF) goto CLOSING;

    // Print comments
    for (l = 0; l <= 10; l++) {
        // Search the beginning of comments between the line src_line
        // and the line src_line + 10
        while ((buf = fgetc(src_fp)) != '\n') {
            if (buf == '/') {
                buf = fgetc(src_fp);
                if (buf == '/') {
                    // find the comments
                    fprintf(fp_out, "%s", head);
                    do {
                        if ((buf = fgetc(src_fp)) == EOF) goto CLOSING;
                        putc(buf, fp_out);
                    } while (buf != '\n');

                    l = 100; continue;
                        // continue printing out comments while they are
                        // found
                }
                if (buf == '\n') break;
                if (buf == EOF) goto CLOSING;
            }
            if (buf == EOF) goto CLOSING;
        }
    }
CLOSING:
    fclose(src_fp);
}


void Eprint(char* src_file, int src_line,
            char* title, Boolean src_comments)
{   //    Eprint(char*,int,char*,Boolean) (define)

    fprintf(stderr, "E : %s : %d : %s\n", src_file, src_line, title);

    if (src_comments == YES) Print_comments(stderr, src_file, src_line);
}


void Wprint(char* src_file, int src_line,
            char* title, Boolean src_comments)
{   //    Wprint(char*,int,char*,Boolean) (define)

    fprintf(stderr, "W : %s : %d : %s\n", src_file, src_line, title);

    if (src_comments == YES) Print_comments(stderr, src_file, src_line);
}


void Eprint_memory(char* src_file, int src_line,
                   char* array_typ, int array_len, Boolean src_comments)
{   //    Eprint_memory(char*,int,char*,int,Boolean)  (define)

    fprintf(stderr,
        "E : %s : %d : Insufficient memory", src_file, src_line);
    if ((array_typ != "") && (array_typ != NULL)) {
        // print array type and array length
        fprintf(stderr, " (%s", array_typ);
        if (array_len > 0) fprintf(stderr, " x %d", array_len);
        fprintf(stderr, ")");
    }
    fprintf(stderr, ".\n");

    if (src_comments == YES) Print_comments(stderr, src_file, src_line);
}


void Eprint_fopen(char* src_file, int src_line,
                  char* fname, char* mode, Boolean src_comments)
{   //    Eprint_fopen(char*,int,char*,char*,Boolean) (define)

    fprintf(stderr,
        "E : %s : %d : Cannot open file \'%s\' (mode \"%s\").\n",
        src_file, src_line, fname, mode);

    if (src_comments == YES) Print_comments(stderr, src_file, src_line);
}


char pick_char(istream& s)
{

    // Checks the status of istream s.  If the stream is in the
    // unrecoverble error state , then it prints out the error message
    // in stderr and exits. Else if the sream is in the fail state, then
    // it clears the fail state and reads in the character which caused
    // the fail state and returns the character. Else if the stream is
    // in the good state, it retruns '\0'

    // KyotoHydro, Tue Aug 16 17:59:32 1994

    char c;
    if (s.eof() || s.bad()) {
        cerr << "unrecoverable istream state" << endl;
        exit(1);
    }
    if (s.fail()) {
        s.clear();
        s >> c;
    }
    else
        c = '\0';
    return c;
}

void skip_white_and_char(istream& s, char c)
{
    // Reads in characters while skipping white characters and the
    // character c. c is skiped only once.

    // KyotoHydro, Tue Aug 16 18:00:00 1994

    char b;
    Boolean flag = NO;
    while (s >> b) {
        if (isspace(b)) continue;
        if (b == c) {
            if (flag == NO) {
                flag = YES;
                continue;
            }
        }
        s.putback(b);
        break;
    }
}

void str2dstr(char* str, char* dstr, int dstrSize) {
    char* p = str;
    for (; *p; p++) {
        if (*p == '\n') { *p = '\0'; break; }
    }
    int len = strlen(str);
    if (dstrSize < len+2) {
        Eprint(__FILE__, __LINE__); exit(1);
    }
    p = str;  char* q = dstr;  char c;  int iflag = 0;
    while (1) {
        while (*p == ' ' || *p == '\t') { p++; }
        if (!*p) { *q++ = 0; if (iflag == 0) q = 0; break; }
        switch (*p) {
            case '\'':
            case '\"':
                c = *p++;
                while (*p != c) {
                    if (*p == 0) { Eprint(__FILE__, __LINE__); exit(1); }
                    *q++ = *p++;
                }
                *q++ = 0;  p++;  iflag = 1;
                break;
            default:
                while (*p != ' ' && *p != '\t' && *p != 0) {
                    *q++ = *p++;
                }
                *q++ = 0;  iflag = 1;
                break;
        }
    }
}

void ignore(FILE* fp, char c)
{
    int s;
    while ((s = fgetc(fp)) != c) {
        if (s == EOF) {
            Eprint(__FILE__, __LINE__); exit(1);
        }
    }
}

/*; Local Variables: *** */
/*; tab-width: 4 *** */
/*; fill-column: 72 *** */
/*; End: *** */

/*; end of file */
