/*;  f_look.h {\documentstyle[fleqn]{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.1 $$ {\rhead{\sl f\_look.h\quad\thepage}} */
/*;  $$Date: 2000/12/02 09:51:02 $$  */
/*;  $$Source: /home/shiiba/ohymos-lib/ohymos-current/f_look.h,v $$  */
/*;  $$RCShost: yodo.kuciv.kyoto-u.ac.jp $$  */

// @(#)  service functios to treat files

#if !defined(f_look_h)
#define f_look_h

#include <stdio.h>

  ////////////////////////////////////////////////////////////////
  // Move forward the file pointer "fp" untill a non-white
  // character is encountered.  Comment strings are also skipped.
  //
  // <japanese>
  // ۥ磻ȥڡ, , ʸ, fp ʤޤ.
  // comment ϡʸ󳫻ϤʸǤ̾ϡ'#' 
  // Ƥcomment  NULL ΤȤϡʸ򥹥
  // פޤ
  // </japanese>
  //
  // <dl><dt>Example<dd>
  //	current = fgetc(fp);
  //    Pass_whites_and_comments(fp, current, '#');
  // </dl>
void Pass_whites_and_comments(
  FILE*& fp,        // file pointer
  char& current,    // input. the character to which the current
                    // "fp" points
                    // output. encountered non-white character
  char comment      // comment character
  );

  ////////////////////////////////////////////////////////////////
  // <japanese>
  // fp ؤե֤ιֹޤ.
  // </japanese>
int Get_line_number(
  FILE*& fp     //; ֹĴ٤եΥݥ
  );

  ////////////////////////////////////////////////////////////////
  // <japanese>
  // ե f_name  fp ʹߤ, head, tail ˰Ϥޤ줿
  // ʬҡפ˳ݤʸ d_str ˥ԡ, ǡʸ
  // ޤ.
  // </japanese>
Boolean Make_data_string(
  char* f_name,     //; ե̾
  FILE*& fp,        //; եݥ
  char& current,    //; fp ؤƤʸ
  char*& d_str,     //; output. ǡʸ
  int& d_strlen,    //; ǡʸĹ
  char head,        //; '('
  char tail,        //; ')'
  char comment,     //; '#'
  char control      //; Ϣ³ʸ '\'
  );
	/*
	  	Make_data_string(char*,FILE*&,char&,char*&,int&,
						 char,char,char,char)
			ǡʸκ

	ե f_name  fp ʹߤ, head_mark, tail_mark ˰Ϥޤ줿ʬ
	פ˳ݤʸ d_str ˥ԡ, ǡʸޤ.

	ǡʸ '\0', '\0' ³ƵҤޤ.
	head_mark, tail_mark 줾 '(', ')', λ,

	ҡפ
	ۥ磻ȥڡǶڤ줿ʸҡפ˥ԡ.

	㤨, head, tail, comment, control 줾 '(', ')', '#', '\' 
	,

		(aaa bbb)					==> |aaa bbb| + |\0\0|

		((aaa) (bbb))				==> [aaa\0bbb\0\0]

		# ʸ...
		((aaa)	# ʸ...
		 (bbb))						==> [aaa]+'\0'+[bbb]+'\0'+'\0'

		(aaa \
		bbb)						==> [aaa \tbbb]+[\0]+[\0]

		(aaa \( \) \\ \# bbb)		==> [aaa ( ) \ # bbb]+[\0]+[\0]

	ARGUMENT:
		f_name	fp Υե̾.
		fp		ǡʸФե֤ؤΥݥ󥿤Ǽ
					뻲Ȱ.
		current	fp ؤƤʸǼ뻲Ȱ.
		head		ǡʸ󳫻Ϥʸ.
		tail		ǡʸλʸ.
		comment	ʸʸ. NULL ξ, Ƚʤ.
		control	Ϣ³, head, tail, comment, control ʸ
					ʸ.
					NULL ξ, Ϣ³, ʸԤʤʤ.
	RETURN:
		char*		ҡפ˺ǡʸؤΥݥ.
		NULL		ǡե뤬եޥåȥ顼ξ.
					head_mark  tail_mark Ʊξ.
	EXIT:
		5			ǡʸѤεΰҡפ˳ݤǤʤ.
					(new)
	*/


  ////////////////////////////////////////////////////////////////
  Boolean Get_string(FILE*& fp, char& current, char*& str, char control);

  ////////////////////////////////////////////////////////////////
int Get_strings(FILE*& fp, char& current,
				char**& str_array, int num_of_strs,
				char comment, char control);

  /* <japanese>
		Get_strings(FILE*&,char&,char**&int,char,char)

	ARGUMENT:
		fp			ʸФե֤ؤΥݥ󥿤Ǽ
						뻲Ȱ.
		current		fp ؤƤʸǼ뻲Ȱ.
		array			ФʸΥݥ󥿤Ǽ뻲Ȱ.
						ʸФǤʤ NULL ꤹ.
						и array Ѥ, ͤȶѤ.
						how_many ȶѤ, ζ줬.
		how_many		Фʸꤹ.
		comment_mark	ʸʸ.
						NULL ξ, ʸʤ.
		control_mark	Ϣ³ʸ.
						NULL ξ, Ϣ³Ԥʤʤ.
	RETURN:
		int			ФǤʸο.
  <japanese> */


#endif	// ! f_look_h

/*; Local Variables: *** */
/*; tab-width: 4 *** */
/*; fill-column: 72 *** */
/*; End: *** */

/*; end of file */
