/*;  adder.h {\documentstyle[fleqn]{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision$$ {\rhead{\sl adder.h\quad\thepage}} */
/*;  $$Date$$  */
/*;  $$Source$$  */
/*;  $$RCShost$$  */

// @(#) adder.h -- class Adder

/* <japanese>
{\ {\setlength{\parskip}{4pt}% latex-mode

ʣĿμüҤǡ򤽤Τޤ޲ûüҤ˽
ֲûǥפΥإåեǤ

\begin{description}
\item[饹̾] Adder

\item[ǥ̾] ûǥ

\item[ǽ] ʣĿμüҤǡ򤽤Τޤ޲û
üҤ˽ϤޤüҤθĿϡ󥹥ȥ饯ǻꤷޤ
ѥ᥿Ϥޤ

\item[üҤλ] üҤθĿϡǤդǤ󥹥ȥ饯ǻꤷ
ޤüҤ갷ǡѥåϡ\verb|Data<double>| Ǥ
üҤȤˡǡϿ郎äƤƤ⹽ޤ

\item[üҤλ] üҤϣĤǤǡϡ
\verb|Data<double>| ǤǡϿϡüҤΥǡ½
Ǥ

\item[ѥ᥿λ] ѥ᥿Ϥޤ

\item[֤λ] ̤ϡ\verb|current_time| Ǥ
\verb|data_string| ɤ߹ؿ¾ˡ
֤ꤹؿȤơ
\begin{verbatim}
	Set_initial_state(time_t ct);
\end{verbatim}

ѰդƤޤϡ\verb|current_time|  ct ꤷޤ

\end{description}

[] üҤϡŪѲǡϤΤȤޤ
ǡޤդͿΤȤơĺλȤλǤ
ǡѥåˤޤȤơüҤͿޤʣμüҤ
ͿǡûȤη̤ޤդˤʤޤ


Ǥϡˤäƽ񤫤ޤ
}% end of latex-mode }
<japanese>
*/

/* adder.h		饹 Adder Υإåե
-----------------------------------------------------------------------
	Adder : ûǥ
------------------------------------------------------------------------
*/

/*----------------------------------------------------------------------
CLASS
    Adder

DESCRIPTION
    add the data obtaiend through receive ports

----------------------------------------------------------------------*/


#if !defined(_adder_h)
#define _adder_h

#include <stdio.h>
#include <iostream.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#include "common.h"        //; ̴Ķ
#include "list.h"          //; 饹 List 
#include "element.h"       //; 饹 Element 
#include "p_tmp.h"         //; ƥץ졼ȥ饹 Receive, Send 


class Adder : public Element {

//; ѥ᥿
protected:
  //////////////////////////////////////////////////////////////////////
  // The number of receive ports
  int ninput;

//; 
protected:
  //////////////////////////////////////////////////////////////////////
  // The sum of the data obtained through receive ports.
  double sum_inflow;			       // üҤϤ. 

//; üҡü
protected:

  //////////////////////////////////////////////////////////////////////
  // Receive port
  Receive<double>* rp;

  //////////////////////////////////////////////////////////////////////
  // Send port
  Send<double> sp;

protected:

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // üҤθĿ ninput ϡ󥹥ȥ饯ޤ Init ؿǻꤷ
  // ޤ ΥдؿǤϡninput Ĥμü rp[i] 򡤽ˡ
  // Ͽޤ
  // </japanese>
  void Register_receive_ports(void);

  //////////////////////////////////////////////////////////////////////
  void Register_send_ports(void)
  {
    Register((void*) &sp);
  }


//; ؿ󥹥ȥ饯ǥȥ饯

private:
  //; ػߤ뤿ޤ
  Adder& operator=(const Adder& rhs);

public:
  //////////////////////////////////////////////////////////////////////
  // Returns a pointer to a new Adder
  Adder* NewElement() { return new Adder(); }

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // [in] o_name   - ֥̾
  // [in] o_num    - ֹ֥
  // [in] numinput - üҤθĿ
  // [in] p_str	   - ǡʸ
  // </japanese>
  Boolean Init(char* o_name, int o_num, int numinput, char* p_str =
				 NULL);

  //////////////////////////////////////////////////////////////////////
  // Constructor
  Adder(char* o_name, int o_num, int numinput, char* p_str = NULL)
		: Element(),
		  sp("sp", 0)
	{
		class_name = "Adder";
		Init(o_name, o_num, numinput, p_str);
	}

  //////////////////////////////////////////////////////////////////////
  // Default constructor
  Adder(void)
		: Element(),
		  sp("sp", 0)
	{ class_name = "Adder"; }

  //////////////////////////////////////////////////////////////////////
  // Destructor
  ~Adder(void)
	{
	    delete [] rp;
	}

//; ѥ᡼ꡦ̤ν
public:
  //////////////////////////////////////////////////////////////////////
  void Set_parameter(FILE*) {}

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // current_time  fscanf(fp, "%ld", &current_time) ɤ
  // ȤäͤѹޤɤߤȤäͤʤѹޤ
  // </japanese>
  void Set_initial_state(FILE* fp);

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // current_time  ct ѹޤ
  // ct ʤѹޤ
  // </japanese>
  void Set_initial_state(time_t ct);

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // current_time  fprintf(fp, "(%ld)", current_time) ǽ񤭽Фޤ
  //
  // </japanese>
  void Save_terminal_state(FILE* fp);

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // current_time  ct ˳ǼäƤޤ
  // </japanese>
  void Save_terminal_state(time_t& ct);

//; ׻ǽ
public:
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ϤûơüҤ˽񤭽Фޤ
  // </japanese>
  Boolean Initial_output(void);

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ߻ʸǡǤŤǡޤǷ׻ʤ뤳Ȥˤơ
  // time_step ׻ޤ
  // </japanese>
  time_t Calculate_time_step(void);

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ̤ϡWork ǸƤФޤAdder  Work Ǥϡtime_step 
  // ׻ǤޤǤꤹ Calculate_time_step ȤΤǡ
  // ؿפǤϡ貾۴ؿʤΤǡŪˤ
  // 褦Ƥޤ
  // </japanese>
  Boolean Can_you_calculate(void) { return YES; }

  //////////////////////////////////////////////////////////////////////
  Boolean Work(void);

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ߻ʸǡǤŤǡμǡβûͤ
  // üҤޤ
  // </japanese>
  Boolean Calculate(void);

};

#endif

/* end of file {\ % The following part will be omitted in tex file
\begin{comment}\begin{verbatim}
This part is not included in the tex output.
$Revision: 1.14 $
Alterations from Revision: 1.13
The return value of member function Initial_output was changed.

Revision: 1.10 ѹ
ֳִ֤ Work λͤѹޤ

Revision: 1.6 ѹ
hymoshist.doc 110 ˽񤤤ѹбޤ

# Local Variables: ***
# tab-width: 4 ***
# End: ***
\end{verbatim}\end{comment}
} */

/*; Local Variables: *** */
/*; tab-width: 4 *** */
/*; fill-column: 72 *** */
/*; End: *** */

/*; end of file */
