/*;  output.h {\documentstyle[fleqn]{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision$$ {\rhead{\sl output.h\quad\thepage}} */
/*;  $$Date$$  */
/*;  $$Source$$  */
/*;  $$RCShost$$  */

// @(#) output.h -- base class for creating output ports

/* <japanese>
{\ {\setlength{\parskip}{4pt}% latex-mode

ܷüҥǥ \verb|Output_port| ޤ, 貾۴
ޤǤݥ饹Ǥ

ܷüҥǥ \verb|Output_port| ˴Ϣط򼨤ޤ

\begin{verbatim}
        Object <-- Port <--+
                           |
     +---------------------+
     |
     +--- Receive_port <-- Output_port <-- Output_file  <--+-- O_file<T>
                                                           |
                                           Port_type<T> <--+
	\end{verbatim}
}% end of latex-mode }
</japanese>
</japanese> */

#if !defined(output_h)
#define output_h

#include <stdio.h>

#include "receive.h"	//; 饹 Receive_port 


//;	饹 Output_port .

/*----------------------------------------------------------------------
CLASS
    Output_port

    Base class for creating output ports

DESCRIPTION

    hello

----------------------------------------------------------------------*/


class Output_port : public Receive_port {
	/* <japanese>
		Output_port		ܷüҤΥǥ
	</japanese> */

//;	1.	³ǽ.
public:
  //////////////////////////////////////////////////////////////////////
  // Returns a string which expresses the type of datapacks received by
  // the current object.  This is a pure virtual function.  This
  // function must be defined in derived classes.
  virtual char* Data_pack_type(void) = NULL;
		/* <japanese>
			Output_port::Data_pack_type(void) (pure virtual)
				ϥǡѥå֤

		貾۴ؿǤ. Output_port 饹, ϥǡѥå
		ɽʸؤΥݥ󥿤֤褦ɬƲ.

		㤨, ϥǡѥå "INT" Ǥ饹Ǥ,
			char* Data_pack_type(void) { return "INT"; }
		Τ褦ޤ.

		³ˤ, üҤȼüҤȤ Data_pack_type פ뤳
		Ȥǧޤ.

		RETURN:
			char*		ϥǡѥåɽʸؤΥݥ.
		</japanese> */

//;	2.	ǡϤ뵡ǽ.
public:
  //////////////////////////////////////////////////////////////////////
  // Get datapacks from the sender and output it.  This is a pure
  // virtual function declaration.  It must be implemented in derived
  // classes.
  virtual void Output_data(void) = NULL;
		/* <japanese>
			Output_port::Output_data(void) (pure virtual)
				ǡν

		ƽüҤ, ǡѥå, ǡϤؿ
		Ʋ.
		</japanese> */

//;	3.	ɽǽ.
	//; Output_port ǤϺޤ.

//;	4.	ǽ, 󥹥ȥ饯, ǥȥ饯.
public:
  //////////////////////////////////////////////////////////////////////
  // Init.
  Boolean Init(char* p_name, int p_num)
		{ return Receive_port::Init(p_name, p_num); }
		/* <japanese>
			Output_port::Init(chaar*,int) (inline)	Ѵؿ

		Receive_port::Init ¹Ԥޤ.

		RETURN:
			YES	.
			NO	Ť˽줿. (Object::Init)
		EXIT:
			5		object_name εΰ褬ݤǤʤ.
					(Object::Init)
		</japanese> */
  //////////////////////////////////////////////////////////////////////
  // Constructor.
  Output_port(char* p_name, int p_num);

  //////////////////////////////////////////////////////////////////////
  // Constructor.
  Output_port(void);

  //////////////////////////////////////////////////////////////////////
  // Destrucotor.
  ~Output_port(void);
		/* <japanese>
			Output_port::Output_port(chaar*,int) 		󥹥ȥ饯
			Output_port::Output_port(void)				󥹥ȥ饯
			Output_port::~Output_port(void) (virtual)	ǥȥ饯

		Out_put_port(char*,int) , 쥯饹 Receive_port Υǥե
		󥹥ȥ饯Ѥ, Output_port::Init Ѥ, Фʲ
		̤ޤ.
			class_name		: "Output_port"
			object_name		: p_name (ҡפ˥ԡ)
			object_number		: p_num
			owner				: NULL
			sender			: NULL

		ǥեȥ󥹥ȥ饯, Output_port::Init ¹Ԥޤ.
		η, ʲȤʤޤ.
			object_name		: NULL
			object_number		: -1
		¾ΥФФ, Ĥ󥹥ȥ饯ƱǤ.
		ξ, Output_port::Init ѤƥФƲ.

		ǥȥ饯, ܴ쥯饹 Object  virtual Ƥޤ.

		ARGUMENT:
			p_name	ü̾.
			p_num		üֹ.
		EXIT:
			5			object_name εΰݤǤʤ.
						(Object::Init)
		</japanese> */
};


#endif	// ! output_h

/*; Local Variables: *** */
/*; tab-width: 4 *** */
/*; fill-column: 72 *** */
/*; End: *** */

/*; end of file */
