/*;  khmkdir.cc {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.1 $$ {\rhead{\sl khmkdir.cc\quad\thepage}} */
/*;  $$Date: 2000/12/02 10:06:00 $$  */
/*;  $$Source: /home/shiiba/ohymos-lib/ohymos-current/khmkdir.cc,v $$  */
/*;  $$RCShost: yodo.kuciv.kyoto-u.ac.jp $$  */

// @(#) extended mkdir

#include "khmkdir.h"

int khmkdir(	  //; make a directory
  char* path,	  //; the directory to be made. Ex. foo/bar
  mode_t mode	  //; mode
  //
  // If the parent directory has not yet created, it will be also
  // created.  For example, path is foo/bar and directory foo
  // does not exist, then foo is also created by this function.
)
{
  #ifdef _MSC_VER // for Visual C++
    struct _stat s;
    int sflag = _stat(path, &s);
    int dirflag = ((s.st_mode & _S_IFMT) == _S_IFDIR);
  #else
    struct stat s;
    int sflag = stat(path, &s);
  #endif
  if (sflag == 0 && ((s.st_mode & S_IFMT) == S_IFDIR)) {
    // already created directory.
    return 0;
  }
  else {
    int n = strlen(path);
	char* apath = (char*)malloc(n + 1);
	strcpy(apath, path);
    if (apath[n-1] == '/') {
      apath[n-1] = '\0';
      n--;
    }
    while (n > 0) {
      if (apath[n-1] == '/') {
        break;
      }
      else {
        n--;
      }
    }
    if (n > 0) {
      char* ppath = (char*)malloc(n + 1);
      for (int i = 0; i < n; i++) {
        ppath[i] = apath[i];
      }
      ppath[n] = '\0';
      int flag = khmkdir(ppath, mode);
      if (flag != 0) {
        return flag;
      }
      else {
        #ifdef _MSC_VER // for Visual C++
          return _mkdir(path);
        #else
          return mkdir(apath, mode);
        #endif
      }
    }
    #ifdef _MSC_VER // for Visual C++
        return _mkdir(path);
    #else
        return mkdir(apath, mode);
    #endif
  }
}

/*; end of file */
