/* mbar.cc {\documentstyle{jsrc2latex}\rhead{\sl mbar.cc\quad\thepage}
   \font\tenrm=cmtt10}饹 MakeBar μ¸
{\ \begin{verbatim}
$Revision: 1.1 $ $Date: 2000/12/02 10:06:15 $  by KyotoHydro
\end{verbatim}}
{\ {\setlength{\parskip}{4pt}% latex-mode

}% end of latex-mode }
*/


/* mbar.cc
----------------------------------------------------------------
   饹 MakeBar μ¸
----------------------------------------------------------------
*/

#include <stdio.h>
#include <iostream>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#include "common.h"                                 /* ̴Ķ */
#include "list.h"                               /* 饹 List  */
#include "element.h"                         /* 饹 Element  */
#include "p_tmp.h"         /* ƥץ졼ȥ饹 Receive, Send  */
//#include "p_tmp.cc"
#include "mbar.h"       		      	     /* 饹 MakeBar  */


void MakeBar::Set_initial_state(FILE* fp)
{
	/*
	 MakeBar::Set_initial_state  ̤
	*/

	time_t tnow;
    if (fscanf(fp, "%ld", &tnow) != 1) {
		printf("E: Cannot scan infomation for initialization.");
		printf("object '%s %d'"
			   " : MakeBar::Set_initial_state\n",
			   object_name, object_number);
		exit(1);
	}
	if (tnow > 0) current_time = tnow;
}

void MakeBar::Set_initial_state(time_t ct)
{
	/*
	 MakeBar::Set_initial_state  ̤
	*/

	if (ct > 0) current_time = ct;
}

void MakeBar::Set_parameter(FILE* fp)
{
    if (fscanf(fp, "%d", &dt) != 1) {
		printf("E: Cannot scan infomation for initialization.");
		printf("object '%s %d'"
			   " : MakeBar::Set_parameter\n",
			   object_name, object_number);
		exit(1);
	}
	if (dt <= 0)
		{ Eprint(__FILE__, __LINE__); Oprint(); exit(1); }
		// illegal parameter value.
}

void MakeBar::Set_parameter(int dt) { 
	MakeBar::dt = dt;   
	if (dt <= 0)
		{ Eprint(__FILE__, __LINE__); Oprint(); exit(1); }
		// illegal parameter value. dt <= 0.

}

Boolean MakeBar::Calculate(void)
{
	/*
	 MakeBar::Calculate  ήз׻
	*/

	double sum = 0., ys;		
	time_t t = current_time, te = current_time + time_step, ts;

	// sum:  current_time  t ޤǤΥǡʬ
	// te:  current_time + time_step
	// ts:	
	// ys:	 ts ǤΥǡ

	void** data_pack_array;
	int number_of_data_packs, ip;

	// current_time ʸκǽΥǡѥåõޤ
	rp.Get_data_pack_array(data_pack_array, number_of_data_packs);
	for (ip = 0; ip < number_of_data_packs; ip++) {
		ts = ((Data<double>*) data_pack_array[ip])->Data_time();
		if (ts > current_time) {
			ys = ((Data<double>*) data_pack_array[ip])->Value();
			break;
		}
	}
	
	// te ޤʬʬͤûޤ
	while (ts < te) {
		sum += 0.5 * (y + ys) * (ts - t);
		t = ts;   y = ys;   ip++;
		ts = ((Data<double>*) data_pack_array[ip])->Data_time();
		ys = ((Data<double>*) data_pack_array[ip])->Value();
	}
	
	// te ޤǤλĤΥ֥åʬͤûޤ
	ys = (y*(ts - te) + ys*(te - t))/(ts - t);
	sum += 0.5 * (y + ys) * (te - t);
	
	// ̤򹹿ޤcurrent_time ϡWork ǹޤ
	y = ys;

	/* ǡν */
	double data = sum/time_step;
	sp.Send_data(te, data);

	return YES;
}
 
/* end of file {\ % The following part will be omitted in tex file
\begin{comment}\begin{verbatim}
This part is not included in the tex output.
$Revision: 1.1 $
Revision: 1.3  ѹ
hymoshist.doc 110 ˽񤤤ѹбޤ

# Local Variables: ***
# tab-width: 4 ***
# End: ***
\end{verbatim}\end{comment}
} */

