/*;  jointstp.h {\documentstyle[fleqn]{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.3 $$ {\rhead{\sl jointbl.h\quad\thepage}} */
/*;  $$Date: 2000/09/15 22:54:40 $$  */
/*;  $$Source: /home/shiiba/ohymos-lib/ohymos-current/ohparts/jointstp.h,v $$  */
/*;  $$RCShost: yodo.kuciv.kyoto-u.ac.jp $$  */

// @(#) jointbl.h -- header file for class JointBl

/*
{\ {\setlength{\parskip}{4pt}% latex-mode
...
}% end of latex-mode }
*/

#ifndef jointstp_h
#define jointstp_h

#include <stdio.h>
#include <iostream.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#include "common.h"        //; ̴Ķ
#include "list.h"          //; 饹 List 
#include "element.h"       //; 饹 Element 
#include "p_tmp.h"         //; ƥץ졼ȥ饹 Receive, Send 

/*----------------------------------------------------------------------
CLASS
    JointStp

    Joint multiple inputs and output the sum of them averaged within
    constant intervals

DESCRIPTION
    An object of class JointStp has a number of receive ports which
    receive Data&lt double&gt data and send sum of the received data averaged
    within constant time intervals through a send port.

    The averaged value from t to t + Dt is sent at t + Dt, where Dt is
    the time interval.

    <japanese>
    [ǥ̾]JointStp

    [ǽ]

    JointStp ϡʣĿ receive port 
    Data&lt;double&gt Υǡ (ǡ³ϡޤǡƥå
    ǡޤϥѥ륹ǡΤ줫) ¤򥹥ƥ
    ץǡ send port Фޤ

     t  t + Dt ޤǤʿͤ򡢻 t + Dt Фޤ

    ɽ
<pre>
    a[0]r[0](t,t+Dt) + a[1]r[1](t,t+Dt) + ... + a[n-1]r[n-1](t,t+Dt))
</pre>
    ׻ƽϤޤn: receive port θĿa[0], a[1],
    ..., a[n-1]: Dt: ֳִ֤Ǥ, r[i](t,t+Dt): iܤμü
    ҥǡλ t  t+Dt δ֤ʿ͡

    ƼüҤΥǡ³ (Data Connection Type, DCT) ϡ

<pre>
      0  
      1  ƥå ( t-Dt  t ޤǤͤ t ˵Ͽ)
      2  ѥ륹
</pre>

    椫򤷤ƻꤷޤ

    [üҤλ]

    üҤθĿϡǤդǤ

    üҤθĿ n ϡ

    <ol>
    <li> 󥹥ȥ饯 JointStp(char* o_name, int o_num, int numinput)
    <li> ¤ե Init Τɲþ
    <li> дؿ Init(char* o_name, int o_num, int numinput)
    <li> дؿ Set_ports(int n)
    </ol>

    Τ줫Ѥƻꤷޤ

    üҤλ̤ͤ󤷤ޤ

    <ul>
    <li> üҤθĿ: Ǥ
    <li> üҤ갷ǡѥåη: Data&lt;double&gt
    <li> üҤΥǡ³: ѥ᥿ǻ
    <li> üҤΥ֥̾: rp
    <li> üҤΥֹ֥: 0, 1, ..., n-1
    </ul>

    [üҤλ]

    <ul>
    <li> üҤ갷ǡѥåη: Data&lt;double&gt
    <li> üҤΥǡ³: ƥå
    <li> üҤΥ֥̾: sp
    <li> üҤΥֹ֥: 0
    </ul>

    [Init Τɲþ]

    ¤ե Init Τɲþˤϡ
<pre>
    n Dt dct[0] a[0] dct[1] a[1] ... dct[n-1] a[n-1]
</pre>
    ͤ¤٤ޤüҤθĿ n ϡInit ɤߤޤDt ʹߤϡ
    Init ǡSet_parameter(FILE*) ȤäɤߤޤDt ʹߤˤĤ
    ϡ[ѥ᥿] 򻲾ȤƤǡδ֤ˤϡ1İʾζ
    ֤ƤǡԤ˽񤱤ʤȤϡʣԤϤäƤ⹽
    ޤ

    [ѥ᥿λ]ѥ᥿ϡ

    <ul>
     <li> üҤǡϤֳִ Dt (sec),
     <li> ƼüҤΥǡ³ dct[0], dct[1], ..., dct[n-1],
     <li> ƼüҤؤΨ a[0], a[1], ... a[n-1]
    </ul>

    ǤüҤΥǡ³DCT ϡ0 (), 1 (ƥå)2
    (ѥ륹) Ǥѥ᥿ϡѥ᥿եˡĤν¤
    ޤ
    <pre>
    Dt dct[0] a[0] dct[1] a[1] ...  dct[n-1] a[n-1]
    </pre>

    JointStp ¤եϿƻѤϡΥѥ᥿
    ͤInit ΤɲþȤͿ褦ˤѥ᥿եˤ
    񤫤ʤǤ

    [֤λ]̤ϡcurrent_time (sec) Ǥ

    ֤ɤ߼ؿϡĤΤ褦Ǥ
<pre>
    void Set_initial_state(FILE* fp) {
      time_t tnow; fscanf(fp, "%ld", &tnow);
      if (tnow > 0) current_time = tnow;
    }
</pre>

    []

    üҤǡñ̡üҤξñ̡üҤ
    Фǡñ̤ä˵ҤޤǤ

    ̤ˤϡüҤǡüҤФǡñ
    ̤Ʊǡ㤨Сm^3/sec ǤꡢüҤξϡ̵Ǥ礦

    ̤ˤϡüҤξñѴΤ˻Ѥ뤳ȤǽǤ
    </japanese>

----------------------------------------------------------------------*/

class JointStp : public Element {
  int mDt;    // sampling interval
  double* mA; // multipliers

  //////////////////////////////////////////////////////////////////////
  // Receive ports
  Receive<double>* mRps;

  //////////////////////////////////////////////////////////////////////
  // The number of receive ports
  int mNumRps;

  //////////////////////////////////////////////////////////////////////
  // Send port
  Send<double> mSp;

  //////////////////////////////////////////////////////////////////////
  void Register_receive_ports(void);

  //////////////////////////////////////////////////////////////////////
  void Register_send_ports(void) { Register((void*)&mSp); }

private:
  // To prohibit substitution.  No implementation
  JointStp& operator=(const JointStp& rhs);

public:
  //////////////////////////////////////////////////////////////////////
  // Returns a pointer to a new JointStp
  //
  // <japanese>
  // ¤եб뤿δؿǤǥեȥ󥹥ȥ饯
  // ˤäƥҡפ˺ǥǥؤΥݥ󥿤֤ޤ
  // </japanese>
  JointStp* NewElement() { return new JointStp(); }

  //////////////////////////////////////////////////////////////////////
  // Init function for SCF.
  //
  // Additional information for Init:
  // <pre>
  //   n Dt dct[0] a[0] dct[1] a[1] ... dct[n-1] a[n-1]
  // </pre>
  // where n: number of receive ports, Dt: time interval,
  // dct[0]. .... dct[n-1]: data connection type, a[0], ... a[n-1]:
  // multipliers
  //
  // <japanese>
  // ¤ե init ؿ"Init Τɲþ" ɤ߼
  // "Init Τɲþ" ʬˤϡ
  // <pre>
  //  n Dt dct[0] a[0] dct[1] a[1] ... dct[n-1] a[n-1]
  // </pre>
  // ͤ¤٤ޤüҤθĿ n ϡInit ɤߤޤDt ʹߤϡ
  // Init ǡSet_parameter(FILE*) ȤäɤߤޤDt ʹߤˤĤ
  // ϡclass JointStp  DESCRIPTION  [ѥ᥿] 򻲾Ȥ
  // Ƥǡδ֤ˤϡ1İʾζ֤Ƥǡ
  // Ԥ˽񤱤ʤȤϡʣԤϤäƤ⹽ޤ
  //
  // ¤եǤϡδؿѥ᥿ɤ߹Τǡѥ᥿ե
  // ˤϡѥ᥿񤫤ʤǤ
  // </japanese>
  Boolean Init(char* o_name, int o_num, FILE* fp);

  //////////////////////////////////////////////////////////////////////
  // [in] o_name   - object name
  // [in] o_num    - object number
  // [in] numinput - number of receive ports
  Boolean Init(char* o_name, int o_num, int numinput);

  //////////////////////////////////////////////////////////////////////
  // Constructor
  JointStp(char* o_name, int o_num, int numinput)
    : Element(),
    mA(NULL), mRps(NULL), mNumRps(0), mSp("sp", 0)
	{
      class_name = "JointStp";
      Init(o_name, o_num, numinput);
	}

  //////////////////////////////////////////////////////////////////////
  // Default constructor
  JointStp(void)
    : Element(),
    mA(NULL), mRps(NULL), mNumRps(0), mSp("sp", 0)
	{ class_name = "JointStp"; }

  //////////////////////////////////////////////////////////////////////
  // Destructor
  ~JointStp(void)
	{
      delete [] mRps;
      delete [] mA;
	}

//; ѥ᡼ꡦ̤ν
public:
  //////////////////////////////////////////////////////////////////////
  // Read in paramters
  //
  // <pre>
  // void Set_parameter(FILE* fp) {
  //  fscanf(fp, "%d", &mDt); int dct;
  //  for (int i = 0; i < mNumRps; i++) {
  //    fscanf(fp, "%d %lf ", &dct, &(mA[i]));
  //    mRps[i].Set_data_connection_type(dct);
  //  }
  // }
  // </pre>
  void Set_parameter(FILE* fp);

  //////////////////////////////////////////////////////////////////////
  // Set the number of receive ports
  void Set_port(int n);

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // current_time  fscanf(fp, "%ld", &current_time) ɤ
  // ȤäͤѹޤɤߤȤäͤʤѹޤ
  // </japanese>
  //
  // <pre>
  // void Set_initial_state(FILE* fp) {
  //  time_t tnow; fscanf(fp, "%ld", &tnow);
  //  if (tnow > 0) current_time = tnow;
  // }
  // </pre>
  //
  void Set_initial_state(FILE* fp) {
    time_t tnow; fscanf(fp, "%ld", &tnow);
    if (tnow > 0) current_time = tnow;
  }

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // current_time  ct ѹޤ
  // ct ʤѹޤ
  // </japanese>
  void Set_initial_state(time_t ct) {
    if (ct > 0) current_time = ct;
  }

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // current_time  fprintf(fp, "%ld", current_time) ǽ񤭽Фޤ
  //
  // </japanese>
  void Save_terminal_state(FILE* fp) {
    fprintf(fp, "%ld", current_time);
  }

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // current_time  ct ˳ǼäƤޤ
  // </japanese>
  void Save_terminal_state(time_t& ct) {
    ct = current_time;
  }

//; ׻ǽ
public:
  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ϤûơüҤ˽񤭽Фޤ
  // </japanese>
  Boolean Initial_output(void);

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // time_step ϡmDt ˸Ǥ
  // </japanese>
  time_t Calculate_time_step(void) { return mDt; }

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ٤ƤμüҤǡNecessary_time_from, Necessary_time_to 
  // ֤δ֤ΥǡǤз׻ǽȽǤޤ
  // </japanese>
  Boolean Can_you_calculate(void) { return Can_you_calculate0(); }

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ׻ֳִ֤Ƥ calculate ¹Ԥ Work0 ѤƤ
  // 
  // </japanese>
  Boolean Work(void) { return Work0(); }

  //////////////////////////////////////////////////////////////////////
  // <japanese>
  // ġμüҤ顢Dt ʿͥǡơ줾
  // ˷褸¤ȤꡢüҤФޤ
  // </japanese>
  Boolean Calculate(void);

};

#endif // jointstp_h

/*; Local Variables: *** */
/*; tab-width: 4 *** */
/*; fill-column: 72 *** */
/*; End: *** */

/*; end of file */
