/*;  ltank.cc {\documentstyle[fleqn]{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.1 $$ {\rhead{\sl ltank.cc\quad\thepage}} */
/*;  $$Date: 2000/10/14 15:10:16 $$  */
/*;  $$Source: /home/shiiba/ohymos-lib/ohymos-current/doc/element/ltank.cc,v $$  */
/*;  $$RCShost: yodo.kuciv.kyoto-u.ac.jp $$  */

// @(#) Implementation of class Ltank

#include <stdio.h>
#include <time.h>

#include "p_tmp.h"
#include "ltank.h"

void Ltank::Save_terminal_state(FILE* fp) {
  if (fp != NULL) {
    fprintf(fp, "%ld %f", current_time, mS);
  }
}

Boolean Ltank::Calculate(void)
{
  time_t t0 = current_time;
  time_t time_step = Calculate_time_step();
  double imean = mC * mRp.Get_mean_data(t0, t0 + time_step);

  mS = mC1 * mS + mC2 * imean; // update the state variable

  double data = mA * mS;
  mSp0.Send_data(t0 + time_step, data); // send data
  data = mB  * mS;
  mSp1.Send_data(t0 + time_step, data); // send data
  return YES;
}

/*; Local Variables: *** */
/*; tab-width: 4 *** */
/*; fill-column: 72 *** */
/*; End: *** */

/*; end of file */
