/* output_f.cc {\documentstyle{jsrc2latex}\rhead{\sl output_f.cc\quad\thepage}
   \font\tenrm=cmtt10}饹 Output_file μ
{\ \begin{verbatim}
$Revision: 1.1 $ $Date: 2000/12/02 10:07:41 $  by KyotoHydro
\end{verbatim}}
{\ {\setlength{\parskip}{4pt}% latex-mode

}% end of latex-mode }
*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>			// time_t , tm 
#include <limits.h>			// LONG_MIN 
#include <string.h>

#include "common.h"			// ץˤ붦
#include "datapack.h"		// 饹 Data_pack 
#include "object.h"			// 饹 Object 
#include "output_f.h"		// 饹 Output_file 


//	饹 Output_file μ.

Boolean Output_file::Write_hedda(void)
{	//		Output_file::Write_hedda(void) (define)

	FILE* fp = fopen(object_name, "w");		// ϥե񤭹.
	if (fp == NULL) {
		Eprint_fopen(__FILE__, __LINE__, object_name, "w");
			// Output_file::Write_hedda(void)
		Oprint(); return NO;
	}

	fprintf(fp, "# %s \n# ", object_name);
	int k;
	for (k = 0; k < 70; k++) fprintf(fp, "-");
	fprintf(fp, "\n");

	((Object*) sender)->Oprint(fp, "#   ");

	fprintf(fp, "# ");
	for (k = 0; k < 70; k++) fprintf(fp, "-");
	fprintf(fp, "\n");
	if (comment_string != NULL) {
	  fprintf(fp, "# %s\n", comment_string);
	}
	char* sendercom = ((Sender_port*) sender)->Get_comment_string();
	if (sendercom != NULL) {
	  fprintf(fp, "# %s\n", sendercom);
	  delete [] sendercom;
	}
	fprintf(fp, "\n");

	fclose(fp); return YES;
}


void Output_file::Output_data(void)
{	//		Output_file::Output_data(void) (define)

	void** dp_array; int num_of_dps;
	Get_data_pack_array(dp_array, num_of_dps);

	if (((Data_pack*) dp_array[num_of_dps - 1])->Data_time()
			<= last_data_time) return;	// ǡѥå̤.

	char* buffer = new char[line_length];	// ѥХåե.
	if (buffer == NULL) {
		Eprint_memory(__FILE__, __LINE__, "char", line_length);
			// Output_file::Output_data(void)
		Oprint(); exit(5);
	}

	if (last_data_time == LONG_MIN) Write_hedda();
		// ν.
		// ޤ,  LONG_MIN ˤǡ򣱸ĤϤ.

	FILE* fp = fopen(object_name, "a");		// ϥեΥץ.
	if (fp == NULL) {
		Eprint_fopen(__FILE__, __LINE__, object_name, "a");
			// Output_file::Output_data(void)
		Oprint(); delete [] buffer; return;
	}

	if (((Data_pack*) dp_array[0])->Data_time() == LONG_MIN) {
 		Make_string_data(buffer, dp_array[0]);
 		fprintf(fp, "%s\n", buffer);
	}

	int k;
	for (k = 0; k < num_of_dps; k++) {	// ϺѤߥǡ.
		if (((Data_pack*) dp_array[k])->Data_time() > last_data_time)
			break;
	}
	for (; k < num_of_dps; k++) {	// ǡν.
 		Make_string_data(buffer, dp_array[k]);
 		fprintf(fp, "%s\n", buffer);
	}

	fclose(fp); delete [] buffer;

	last_data_time = ((Data_pack*) dp_array[num_of_dps - 1])->Data_time();
	Reduce_data_pack_stock();
}


void Output_file::Cprint(FILE* fp_out, char* head)
{	//		Output_file::Cprint(FILE*,char*) (define)

	fprintf(fp_out,
		"%sInput_file : %s<%s> %s \n",
		head, class_name, Data_pack_type(), object_name);
}


// void Output_file::Oprint(FILE* fp_out, char* head)
// {	//		Output_file::Oprint(FILE*,char*) (define)
//
// 	Cprint(fp_out, head);
//
// 	if (sender == NULL) return;
//
// 	fprintf(fp_out, "%s", head);
// 	((Object*) sender)->Cprint(fp_out, "    Data from > ");
// }


// modified by Suzuki,T (Sat Feb 10 15:45:42 1996)
void Output_file::Oprint(FILE* fp_out, char* head)
{
    Cprint(fp_out, head);

    if (sender == NULL) return;

    // üҾϤΥإå롣
    char* head_add = "  output < ";
    int len = strlen(head) + strlen(head_add) + 1;
    char* head_new = new char[len];
    if (head_new != NULL) {
        strcpy(head_new, head); strcat(head_new, head_add);
    } else {
        Eprint_memory(__FILE__,__LINE__,"char",len);
            // Input_file::Oprint(FILE*,char*)
            // For headder string to write infomation
        head_new = head;
    }

    ((Object*) sender)->Oprint(fp_out, head_new);

    if (head_new != head) delete [] head_new;
}


void Output_file::Set_comment_string(char* cmt)
{
    int len = strlen(cmt) + 1;
    comment_string = new char[len];
    if (comment_string != NULL) {
        strcpy(comment_string, cmt);
    } else {
        Eprint_memory(__FILE__,__LINE__,"char",len);
    }
}

Boolean Output_file::Init(char* f_name, int l_len)
{	//		Output_file::Init_member(char*,int) (define)

// @begin{commented out by shiiba} -------------------------------------
//
//  if (l_len <= 0) { Eprint(__FILE__, __LINE__); Oprint(); return NO; }
//		// Output_file::Init(char*,int)
//		// Invalid value "l_len" (arg).
//
// @end{commented out by shiiba} ---------------------------------------

// @begin{inserted by shiiba} ------------------------------------------

   if (l_len < 0) { Eprint(__FILE__, __LINE__); Oprint(); return NO; }
   if (l_len == 0) l_len = 128;

// @end{inserted by shiiba} --------------------------------------------


  if ((Object::Init(f_name, 0) != YES) || (line_length > 0))
  { Eprint(__FILE__, __LINE__); Oprint(); return NO; }
			// Output_file::Init(char*,int)
			// Doubly initialized.

  line_length = l_len; return YES;
}


Output_file::Output_file(char* f_name, int l_len)
	:	Output_port(),
		line_length(-1), last_data_time(LONG_MIN)
{	//		Output_file::Output_file(char*,int) (define)

	class_name = "Output_file";
	comment_string = NULL;
	Init(f_name, l_len);
}


Output_file::Output_file(void)
	:	Output_port(),
		line_length(-1), last_data_time(LONG_MIN)
{	//		Output_file::Output_file(void) (define)

	class_name = "Output_file";
	comment_string = NULL;
}


Output_file::~Output_file(void)
{	//		Output_file::~Output_file(void) (define)
	delete [] comment_string;
}

/* end of file {\ % The following part will be omitted in tex file
\begin{comment}\begin{verbatim}
This part is not included in the tex output.
$Revision: 1.1 $
Revision: 1.2 ѹ
delete ʸ delete [] 

# Local Variables: ***
# tab-width: 4 ***
# End: ***
\end{verbatim}\end{comment}
} */
