/*;  p_tmp.cc {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.2 $$ {\rhead{\sl p\_tmp.cc\quad\thepage}} */
/*;  $$Date: 2000/12/02 10:10:27 $$  */
/*;  $$Source: /home/shiiba/ohymos-lib/ohymos-current/p_tmp.cc,v $$  */
/*;  $$RCShost: yodo.kuciv.kyoto-u.ac.jp $$  */

// @(#) template classes Data<T>, Receive<T>, Send<T>, I_file<T>,
// and O_file<T>

#if !defined(p_tmp_cc)
#define p_tmp_cc

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <time.h>		// Definition of types time_t and tm

#include "p_tmp.h"

	// Definitions of template classes Send, Receive, I_file, O_file
#include "data2str.h"

// #include <strstream.h>
#include <sstream>

//  Implementaion of Data<T>

template <class T>
Data<T>::Data(char*& dstr) : Data_pack(), Port_type<T>()
{
	dstr2data(dstr, data_time);
	dstr2data(dstr, value);
}

template <class T>
void Data<T>::Dstr2dpack(char*& dstr)
{
	dstr2data(dstr, data_time);
	dstr2data(dstr, value);
}

// template <class T>
// void Data<T>::Dpack2ofile(FILE* fp)
// {
// 	fprintf(fp, "%ld", data_time);
// 	data2ofile(value, fp);
// }

// modified by Suzuki,T (Sat Feb 10 15:52:49 1996)
template <class T>
void Data<T>::Dpack2ofile(FILE* fp)
{
	fprintf(fp, "%ld", data_time);
	fputc(' ', fp);
	data2ofile(value, fp);
}

template <class T>
void Data<T>::Dpack2file(FILE* fp)
{
	data2file(data_time, fp);
	data2file(value, fp);
}

//	Implementaion of template class Receive

template <class T>
void Receive<T>::Set_data_connection_type(int dct)
{
	  switch (dct) {
	    case 0: data_connection_type = Brokenline; break;
		case 1: data_connection_type = Step; break;
		case 2: data_connection_type = Pulse; break;
		default:
		  Eprint(__FILE__, __LINE__);
		  // illegal data connection type specification
		  Oprint();
		  exit(1);
	  }
}

template <class T>
T Receive<T>::Get_data(time_t t)
{
	T v; // return value

	// Get data_pack
	void** data_pack_array;
	int number_of_data_packs, ip;

	Get_data_pack_array(data_pack_array, number_of_data_packs);

	assert(number_of_data_packs > 0);

	time_t ta = ((Data<T>*) data_pack_array[0])->Data_time();
	time_t tb =
	((Data<T>*) data_pack_array[number_of_data_packs-1])->Data_time();

	// Is\'n there inconsistency in data?
	assert(t >= ta && t <= tb);

	switch (data_connection_type) { // ------------------ switch starts

	case Brokenline:

	  {
	    int ip1 = 0;
	    int ip2 = number_of_data_packs - 1;
	    time_t t1 = ((Data<T>*) data_pack_array[ip1])->Data_time();
	    time_t t2 = ((Data<T>*) data_pack_array[ip2])->Data_time();
	    while (ip2 - ip1 > 1) {
	      ip = (ip2 + ip1)/2;
	      time_t tp = ((Data<T>*) data_pack_array[ip])->Data_time();
	      if (tp < t) {
		ip1 = ip;  t1 = tp;
	      }
	      else if (tp > t) {
		ip2 = ip;  t2 = tp;
	      }
	      else {
		return ((Data<T>*) data_pack_array[ip])->Value();
	      }
	    }
	    T y1 = ((Data<T>*) data_pack_array[ip1])->Value();
	    if (ip1 == ip2) { return y1;}
	    T y2 = ((Data<T>*) data_pack_array[ip2])->Value();
//             // modified by iYutaka (Fri Oct 28 15:03:39 2005)
//  	    v = ((t - t1)*y2 + (t2 - t)*y1)/(t2 - t1);
	    v = (y2*(t - t1) + y1*(t2 - t))/(t2 - t1);
	  }

	  break;

	case Step:

	  {
	    int ip1 = 0;
	    int ip2 = number_of_data_packs - 1;
	    time_t t1 = ((Data<T>*) data_pack_array[ip1])->Data_time();
	    time_t t2 = ((Data<T>*) data_pack_array[ip2])->Data_time();
	    while (ip2 - ip1 > 1) {
	      ip = (ip2 + ip1)/2;
	      time_t tp = ((Data<T>*) data_pack_array[ip])->Data_time();
	      if (tp < t) {
		ip1 = ip;  t1 = tp;
	      }
	      else if (tp > t) {
		ip2 = ip;  t2 = tp;
	      }
	      else {
		return ((Data<T>*) data_pack_array[ip])->Value();
	      }
	    }
	    v = ((Data<T>*) data_pack_array[ip2])->Value();
	  }

	  break;

	case Pulse:

	  {
	    int ip1 = 0;
	    int ip2 = number_of_data_packs - 1;
	    time_t t1 = ((Data<T>*) data_pack_array[ip1])->Data_time();
	    time_t t2 = ((Data<T>*) data_pack_array[ip2])->Data_time();
	    while (ip2 - ip1 > 1) {
	      ip = (ip2 + ip1)/2;
	      time_t tp = ((Data<T>*) data_pack_array[ip])->Data_time();
	      if (tp < t) {
		ip1 = ip;  t1 = tp;
	      }
	      else if (tp > t) {
		ip2 = ip;  t2 = tp;
	      }
	      else {
		return ((Data<T>*) data_pack_array[ip])->Value();
	      }
	    }
	    if (t == t1) {
	      v = ((Data<T>*) data_pack_array[ip1])->Value();
	    }
	    else if (t == t2) {
	      v = ((Data<T>*) data_pack_array[ip2])->Value();
	    }
	    else {
	      v = (T)0;
	    }
	  }

	  break;

	default:
	  Eprint(__FILE__, __LINE__);
	    // Illegal data_connection_type.
		exit (1);


	} // --------------------------------------------------- switch ends

	return v;
}

template <class T>
Boolean
ReceiveNointp<T>::Get_pulse_data(
  time_t t,		  // data_time
  T& v			  // data value at time "t"
  // If the datapack at time t exists, returns YES and the data
  // value is stored in "v".  Otherwise, returns NO.
)
{

  // Get data_pack
  void** data_pack_array;
  int number_of_data_packs, ip;

  Get_data_pack_array(data_pack_array, number_of_data_packs);

  // assert(number_of_data_packs > 0);
  if (number_of_data_packs <= 0) return NO;

  time_t ta = ((Data<T>*) data_pack_array[0])->Data_time();
  time_t tb =
	((Data<T>*) data_pack_array[number_of_data_packs-1])->Data_time();

  // Is\'n there inconsistency in data?
  // assert(t >= ta && t <= tb);
  if (t < ta || t > tb) return NO;

  time_t tn; T yn;			// next data_pack
  time_t tp; T yp;			// previous data_pack
  tn = ta; yn = ((Data<T>*)data_pack_array[0])->Value();
  if (t == tn) { v = yn; return YES; }
  Boolean hit = NO;
  for (ip = 1; ip < number_of_data_packs; ip++) {
	tp = tn;  yp = yn;
	tn = ((Data<T>*) data_pack_array[ip])->Data_time();
	yn = ((Data<T>*) data_pack_array[ip])->Value();
	if (tn > t) {
	  hit = NO; break;
	}
	else if (tn == t) {
	  v = yn; hit = YES; break;
	}
  }
  return hit;
}

template <class T>
Boolean
Receive<T>::Get_pulse_data(
  time_t t,		  // data_time
  T& v			  // data value at time "t"
  // If the datapack at time t exists, returns YES and the data
  // value is stored in "v".  Otherwise, returns NO.
)
{

  // Get data_pack
  void** data_pack_array;
  int number_of_data_packs, ip;

  Get_data_pack_array(data_pack_array, number_of_data_packs);

  // assert(number_of_data_packs > 0);
  if (number_of_data_packs <= 0) return NO;

  time_t ta = ((Data<T>*) data_pack_array[0])->Data_time();
  time_t tb =
	((Data<T>*) data_pack_array[number_of_data_packs-1])->Data_time();

  // Is\'n there inconsistency in data?
  // assert(t >= ta && t <= tb);
  if (t < ta || t > tb) return NO;

  time_t tn; T yn;			// next data_pack
  time_t tp; T yp;			// previous data_pack
  tn = ta; yn = ((Data<T>*)data_pack_array[0])->Value();
  if (t == tn) { v = yn; return YES; }
  Boolean hit = NO;
  for (ip = 1; ip < number_of_data_packs; ip++) {
	tp = tn;  yp = yn;
	tn = ((Data<T>*) data_pack_array[ip])->Data_time();
	yn = ((Data<T>*) data_pack_array[ip])->Value();
	if (tn > t) {
	  hit = NO; break;
	}
	else if (tn == t) {
	  v = yn; hit = YES; break;
	}
  }
  return hit;
}

template <class T>
T Receive<T>::Get_data_sum(time_t t1, time_t t2)
{					// sum for t (t1 < t <= t2)

	// Is\'nt there inconsistency in data?
	assert(t1 <= t2);

	T sum = 0;
	if (t1 == t2) { return sum; }

	// Get data_pack
	void** data_pack_array;
	int number_of_data_packs, ip;

	Get_data_pack_array(data_pack_array, number_of_data_packs);

	assert(number_of_data_packs > 1);

	time_t ta = ((Data<T>*) data_pack_array[0])->Data_time();
	time_t tb =
	((Data<T>*) data_pack_array[number_of_data_packs-1])->Data_time();

	// Is\'n there inconsistency in data?
	assert(t1 >= ta && t2 <= tb);

	switch (data_connection_type) { // ------------------- switch starts

	case Brokenline:

	  {
	    T y, ya, yb;
	    int ipa = 0;
	    int ipb = number_of_data_packs - 1;
	    time_t ta = ((Data<T>*) data_pack_array[ipa])->Data_time();
	    time_t tb = ((Data<T>*) data_pack_array[ipb])->Data_time();
	    while (ipb - ipa > 1) {
	      ip = (ipb + ipa)/2;
	      time_t tp = ((Data<T>*) data_pack_array[ip])->Data_time();
	      if (tp < t1) {
		ipa = ip;  ta = tp;
	      }
	      else if (tp > t1) {
		ipb = ip;  tb = tp;
	      }
	      else {
		ipb = ip;
		ipa = ip-1;
		tb = tp;
		ta = ((Data<T>*) data_pack_array[ipa])->Data_time();
		break;
	      }
	    }
	    ya = ((Data<T>*) data_pack_array[ipa])->Value();
	    yb = ((Data<T>*) data_pack_array[ipb])->Value();
	    if (ipa == ipb) { y = ya;}
//             // modified by iYutaka (Fri Oct 28 15:02:03 2005)
//  	    else {y = ((t1 - ta)*yb + (tb - t1)*ya)/(tb - ta);} 
	    else {y = (yb*(t1 - ta) + ya*(tb - t1))/(tb - ta);}
	    time_t t = t1;
	    ip = ipb;
	    time_t ts = tb;
	    T ys = yb;

	    // printf("ts = %ld, ys = %lf\n", ts, ys);

	    // Add the integrated value of the broken line portion before
	    // time t2
	    while (ts < t2) {
	      sum += (y + ys) * (ts - t) / 2;
	      t = ts;   y = ys;   ip++;
	      ts = ((Data<T>*) data_pack_array[ip])->Data_time();
	      ys = ((Data<T>*) data_pack_array[ip])->Value();
	    }

	    // Add the integrated value untill time t2
	    // ts >= t2 > t
	    ys = (y*(ts - t2) + ys*(t2 - t))/(ts - t);
	    sum += (y + ys) * (t2 - t) / 2;

	  }

      break;

	case Step:

	  {
	    int ipa = 0;
	    int ipb = number_of_data_packs - 1;
	    time_t ta = ((Data<T>*) data_pack_array[ipa])->Data_time();
	    time_t tb = ((Data<T>*) data_pack_array[ipb])->Data_time();
	    while (ipb - ipa > 1) {
	      ip = (ipb + ipa)/2;
	      time_t tp = ((Data<T>*) data_pack_array[ip])->Data_time();
	      if (tp < t1) {
		ipa = ip;  ta = tp;
	      }
	      else if (tp > t1) {
		ipb = ip;  tb = tp;
	      }
	      else {
		ipb = ip;
		ipa = ip-1;
		tb = tp;
		break;
	      }
	    }
	    time_t tn = tb;  ip = ipb;
	    T yn = ((Data<T>*) data_pack_array[ip])->Value();

	    time_t ts = t1;

	    // Add the bar part before t2
	    while (tn < t2) {
	      sum += yn * (tn - ts);
	      ts = tn;   ip++;
	      tn = ((Data<T>*) data_pack_array[ip])->Data_time();
	      yn = ((Data<T>*) data_pack_array[ip])->Value();
	    }

	    // Add the remaining bar untill time t2
	    if (t2 <= tn) {
	      sum += yn * (t2 - ts);
	    }
	  }
	  break;

	case Pulse:

	  {
	    int ipa = 0;
	    int ipb = number_of_data_packs - 1;
	    time_t ta = ((Data<T>*) data_pack_array[ipa])->Data_time();
	    time_t tb = ((Data<T>*) data_pack_array[ipb])->Data_time();
	    while (ipb - ipa > 1) {
	      ip = (ipb + ipa)/2;
	      time_t tp = ((Data<T>*) data_pack_array[ip])->Data_time();
	      if (tp < t1) {
		ipa = ip;  ta = tp;
	      }
	      else if (tp > t1) {
		ipb = ip;  tb = tp;
	      }
	      else {
		ipb = ip+1;
		break;
	      }
	    }
	    ip = ipb;

	    time_t tn; T yn;
	    for (; ip < number_of_data_packs; ip++) {
	      tn = ((Data<T>*) data_pack_array[ip])->Data_time();
	      yn = ((Data<T>*) data_pack_array[ip])->Value();
	      if (tn > t2) break;
	      sum += yn;
	    }
	  }
	  break;

	default:
	  Eprint(__FILE__, __LINE__);
	    // Illegal data_connection_type.
		exit (1);

	}

	/* Output of data */
	return sum;
}

//	Implementation of template class Send

template <class T>
void Send<T>::Send_data(time_t t, const T& v)
{	//		Send::Send_data  (define)

	Data<T>* dp = new Data<T>;
	if (dp == NULL)
		{ Eprint_memory(__FILE__, __LINE__, "Data", YES); Oprint(); exit(5); }
			// <Send::Send_data>
			// For object of Data (Data_pack).

	dp->Set_data(t, v);
	Stock((void*) dp);
}

template <class T>
void Send<T>::Send_by_string(char*& dstr)
{	//		Send<T>::Send_by_string(char*& dstr)

	Data<T>* dp = new Data<T>;
	if (dp == NULL)
		{ Eprint_memory(__FILE__, __LINE__, "Data", YES); Oprint(); exit(5); }
			// <Send::Send_data>
			// For object of Data (Data_pack).

	dp->Dstr2dpack(dstr);
	Stock((void*) dp);
}

//	Implementation of template class I_file

template <class T>
void* I_file<T>::Make_data_pack(char* line_data)
{	//		I_file::Make_data_pack  (define)

	Data<T> *dp = new Data<T>;
	if (dp == NULL)
		{ Eprint_memory(__FILE__, __LINE__, "Data", YES); Oprint(); exit(5); }
			// <I_file::Make_data_pack>
			// For object of Data (Data_pack).

	int len = strlen(line_data) + 2;
	char* dstr = new char[len];
	char* pc = line_data;  char* qc = dstr;
	while (1) {
		while (*pc == ' ' || *pc == '\t')
			pc++;
		if (*pc == '\n' || *pc == '\0') { *qc++ = '\0'; break; }
		if (*pc == '\'' || *pc == '\"') {
			char c = *pc++;
			while (*pc != c && *pc != '\0' && *pc != '\n') {
				*qc++ = *pc++;
			}
			*qc++ = '\0';
			if (*pc =='\0' || *pc == '\n') break;
			continue;
		}
		while (*pc != ' ' && *pc != '\t' && *pc != '\n' && *pc != '\0')
			*qc++ = *pc++;
		*qc++ = '\0';
	}
	*qc = '\0';  qc = dstr;
	dp->Dstr2dpack(qc);

	delete [] dstr;
	return ((void*) dp);
}

template <class T>
void I_file<T>::Send_by_string(char*& dstr)
{	//		I_file<T>::Send_by_string(char*& dstr)

	Data<T>* dp = new Data<T>;
	if (dp == NULL)
		{ Eprint_memory(__FILE__, __LINE__, "Data", YES); Oprint(); exit(5); }
			// <Send::Send_data>
			// For object of Data (Data_pack).

	dp->Dstr2dpack(dstr);
	Stock((void*) dp);
}

//	Implementation of template class O_file

template <class T>
void O_file<T>::Output_data(void)
{	//		Output_file<T>::Output_data(void) (define)

	void** dp_array; int num_of_dps;
	Get_data_pack_array(dp_array, num_of_dps);

	if (((Data_pack*) dp_array[num_of_dps - 1])->Data_time()
			<= last_data_time) return;	// Data_pack_array has not been
										// renewed.

	char* buffer = new char[line_length];	// Buffer for output
	if (buffer == NULL) {
		Eprint_memory(__FILE__, __LINE__, "char", line_length);
			// Output_file::Output_data(void)
		Oprint(); exit(5);
	}

	if (last_data_time == LONG_MIN) Write_hedda();
		// The first time output

	FILE* fp = fopen(object_name, "a");		// Open the output file
	if (fp == NULL) {
		Eprint_fopen(__FILE__, __LINE__, object_name, "a");
			// Output_file::Output_data(void)
		Oprint(); delete [] buffer; return;
	}

	if (((Data_pack*) dp_array[0])->Data_time() == LONG_MIN) {
		((Data_pack*)dp_array[0])->Dpack2ofile(fp);
		fprintf(fp, "\n");
	}

	int k;
	for (k = 0; k < num_of_dps; k++) {	// Skip the data which have
											// been output.
		if (((Data_pack*) dp_array[k])->Data_time() > last_data_time)
			break;
	}
	for (; k < num_of_dps; k++) {	// Output the data
		((Data_pack*)dp_array[k])->Dpack2ofile(fp);
		fprintf(fp, "\n");
	}

	fclose(fp); delete [] buffer;

	last_data_time = ((Data_pack*) dp_array[num_of_dps - 1])->Data_time();
	Reduce_data_pack_stock();
}

#endif // ! p_tmp_cc

/*; end of file */
