/*;  tram_storage_slope.h {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.2 $$ {\rhead{\sl tram_storage_slope.h\quad\thepage}} */
/*;  $$Date: 2000/08/31 09:27:14 $$  */
/*;  $$Source: /home/kanazawa/kenkyu/models/sample/sample6/tram_storage_slope.h,v $$  */
/*;  $$RCShost: kizugawa.kuciv.kyoto-u.ac.jp $$  */

// @(#) tram_storage_slope
#if !defined(tram_storage_slope_h)
#define tram_storage_slope_h

#include <stdio.h>
#include <iostream.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <fstream.h>
#include <math.h>

#include "common.h"             //; ̴Ķ
#include "element.h"
#include "p_tmp.h"
#include "khmkdir.h"
//#include "dfopen.h"
//#include "khslist.h"
//#include "khrbktree.h"

//#include "tram_storage_subbasin.h"

/*----------------------------------------------------------------------
CLASS
  TramStorageSlope

DESCRIPTION

  <japanese>
   

  [饹̾] TramStorageSlope

  [ǥ̾] αؿǥ

  [ǽ] αؿǥ
         ü
           q_i = \alpha s_i$^m$
           frac{d s_i}{dt}
            = r \Sigma^{M_i}_{j=i}Q_i/A_i - \alpha s_i$^m$
           Q_i = q_i A_i
	  TRAM ˡˤäƷ׻ޤ

  [üҤλ] ߿̤μüҤϰĤǡReceive<double> 
  ֥̾ rpprecֹ֥ 0 Ǥޤ̾ήü
  ή̤μüҤܤή¦ǸĤꡢReceive<double>
  ֥̾ rpdisֹ֥ 0,1,2,...,n ǡή
  (m^3/sec)ޤηޤ

  [üҤλ] üҤϰĤǡSend<douuble> ֥
  ̾ spdisֹ֥ 0 Ǥꡢή(m^3/sec)ޤη
  ǽϤޤ

  [ѥ᥿] ǤŪħ򼨤ѥ᥿ʿĹ(m)
  (ʿĹ(m)/㺹(m))(̤ײꡢ:90)
  ʿ(m^2) ǤΥѥ᥿η
  alpha(m^(1-mM)sec)λؿ m(-)߱ǡ³(0ޤ
  1:ƥåס2:ѥ륹)߱ǡñ̤m/secˤ뤿
  Ψήüήǡñ̤m^3/secˤ뤿Ψδ
  (m)(-)˥ѥե饰(1:)

  [] α s(m)

  [­]
  </japanese>
*/

//;  αؿǥ饹 TramStorageSlope 
class TramStorageSlope : public Element {

  long mNum;                  //; ֹ
  int mNumRps;                //; ή receive port ο
//  int mNumberOfUpperSlopes;   //; ή˰֤륨åο
  long* mpUpperSlopeNumArray; //; ή˰֤륨åֹ
			      //; ؤΥݥ
//  TramStorageSlope** mppUpperSlopeArray; //; ή˰֤륨å
					 //; Υɥ쥹򵭲
  int mAtr;                   //; å°
                              //; 1:ή-ή 2:ή-ƻ
//  Boolean mLowestEdge;        //; ° 2 ǤĲή¦ήХå
			      //; ¸ߤʤȤ YES, ʳ NO
  Boolean mLowestSlope;       //; ° 1 ǤĲή¦ήХå
			      //; ° 2 ǤȤ YES, 
			      //; ʳ NO
  double mLength;             //; ʿĹ
//  double mAngle;              //; ̷(⤵κ/ʿΥ)
  double mTheta;              //; 
  double mArea;               //; ǿʿ
  double mWidth;              //; ή (m)
  double mSin;                //; åθ(sin) (-)
  double mCos;                //; åθ(cos) (-)

  Boolean mFlag;              //; monitor ѤΥե饰 Ѥʤ
			      //; YES

  double mAlpha;              //; η(m^(1-mM)sec)
  int mM;                     //; ξ(-)
  int mDataConnectionTypeP;   //; ߱ü ǡ 0:ޤ 1:
			      //; ƥå 2:ѥ륹
  double mCprec;              //; ̤߱(m^3/sec)ˤ뤿Ψ
  double* mCqup;              //; ήüή̤Ψ
  double mSlevel;             //; δ (m)
  double mEps;                //; (㤨0.001)

  double mS_crnt;             //; θ (m)

  double mrPsum_last;         //; ̤߱ (m)
  double mSsmall;             //; κʬ׻Ǥڤ
			      //; ٥ (m)
  double mS_next;             //; μ (m)
  double mS_last;             //;  (m)
  double mQ_crnt;             //; ήйθ (m/sec)
  double mQ_next;             //; ήйμ (m/sec)
  double mQ_last;             //; ήй (m/sec)
  Boolean mHalvedp;           //; ׻ϻ⤷Ϸ׻ֳִ֤
			      //; Ⱦʬˤľ夫:YES,Ǥʤ:
			      //; NO
  Boolean mDoubledp;          //; ׻ֳִ֤ܤˤʤä:YES,
			      //; Ǥʤ:NO
  int mTime;                  //; ߤη׻ֳִ֤Ǥڤ
			      //; ɾ򥯥ꥢϢ³
  int mTime_max;              //; mTime ξ mTime_max > mTime
			      //; Ȥʤä׻ֳִ֤ܤˤ

  long mDt_next;              //; η׻η׻ֳִ

public:

  //////////////////////////////////////////////////////////////////////
  int Num(void) { return mNum; }

  //////////////////////////////////////////////////////////////////////
  double Length(void) { return mLength; }
//  double Angle(void) { return mAngle; }

  //////////////////////////////////////////////////////////////////////
  double Theta(void) { return mTheta; }

  //////////////////////////////////////////////////////////////////////
  double Area(void) { return mArea; }

  //////////////////////////////////////////////////////////////////////
  double Atr(void) { return mAtr; }

  //////////////////////////////////////////////////////////////////////
  Boolean LowestSlope(void) { return mLowestSlope; }
//  int NumberOfUpperSlopes(void) { return mNumberOfUpperSlopes;}
//  long UpperSlopeNumArray(int i) { return mpUpperSlopeNumArray[i];}
//  Boolean RegisterUpperSlope(TramStorageSlope*);

protected:
  //////////////////////////////////////////////////////////////////////
  //; ü
  Send<double> mSpSlope;      //; ή(m^3/sec)ޤǡǽ

  //////////////////////////////////////////////////////////////////////
  //; üҤϿ
  void Register_send_ports(void);

  //////////////////////////////////////////////////////////////////////
  //; ü
  Receive<double>* mpRpSlope; //; ή(m^3/sec)ޤǡ
  //////////////////////////////////////////////////////////////////////
  Receive<double> mRpClm;     //; ̤߱μü

  //////////////////////////////////////////////////////////////////////
  //; üҤϿ
  void Register_receive_ports(void);

  //////////////////////////////////////////////////////////////////////
  ofstream monitor_storage, monitor_deltaT;

public:
  //////////////////////////////////////////////////////////////////////
  void Set_parameter(FILE* fp);
  //////////////////////////////////////////////////////////////////////
  void Set_initial_state(FILE* fp);
  //////////////////////////////////////////////////////////////////////
  Boolean Initial_output(void);
  //////////////////////////////////////////////////////////////////////
  time_t Calculate_time_step(void) { return mDt_next; }  //; Work0ξ

  //////////////////////////////////////////////////////////////////////
  //; ׻ϻ time step ޤǤΥǡ YES
  Boolean Can_you_calculate(void) { return Can_you_calculate0();}

  //////////////////////////////////////////////////////////////////////
  Boolean Calculate(void);
  //////////////////////////////////////////////////////////////////////
  Boolean Work(void);
  //////////////////////////////////////////////////////////////////////
  void Save_terminal_state(FILE* fp);

  //////////////////////////////////////////////////////////////////////
  // Returns a pointer to a new TramStorageSlope
  TramStorageSlope* NewElement(void);

public:
  //////////////////////////////////////////////////////////////////////
  //; 󥹥ȥ饯
  TramStorageSlope(char* o_name, int o_num);
  //////////////////////////////////////////////////////////////////////
  TramStorageSlope(void);
  //////////////////////////////////////////////////////////////////////
  //; ǥȥ饯
  ~TramStorageSlope(void);

  //////////////////////////////////////////////////////////////////////
  // ¤ե init ؿ"Init Τɲþ" ʬˤϡ
  // üҤθĿ񤭤ޤ
  Boolean Init(char* o_name, int o_num, FILE* fp);

  //////////////////////////////////////////////////////////////////////
  Boolean Init(char* o_name, int o_num);

public:
//  time_t MediumTermTargetTime(void);

};// end of class TramStorageSlope

// typedef KhKeyedData<long,TramStorageSlope*> KeyData;

#endif

/*; Local Variables: *** */
/*; tab-width: 4 *** */
/*; fill-column: 72 *** */
/*; End: *** */

/*; end of file */
