/*;  tram_storage_river.h {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.1 $$ {\rhead{\sl tram_storage_river.h\quad\thepage}} */
/*;  $$Date: 2000/09/18 00:57:05 $$  */
/*;  $$Source: /home/shiiba/ohymos-lib/ohymos-current/ohparts/tram_plaw_storage.cc,v $$  */
/*;  $$RCShost: yodo.kuciv.kyoto-u.ac.jp $$  */

// @(#) tram_storage_river
#include "tram_plaw_storage.h"

//; class TramStorageRiver ˴ؤ뤪á

// const long MaxDT = 16384;  //; Ȥꤢ 214
const long MaxDT = 2048;  //; Ȥꤢ 211

//;  󥹥ȥ饯ؿ
TramPowerLawStorage::TramPowerLawStorage(char* o_name, int o_num)
  : Element(),
    mAlpha(NULL), mM(NULL), mCqup(NULL), mDoubledp(NO), mTime_max(5),
    mpSp(NULL), mpRp(NULL)
{
  class_name = "TramPowerLawStorage";
  Init(o_name, o_num);
}

TramPowerLawStorage::TramPowerLawStorage(void)
  : Element(),
    mAlpha(NULL), mM(NULL), mCqup(NULL), mDoubledp(NO), mTime_max(5),
    mpSp(NULL), mpRp(NULL)
{
  class_name = "TramPowerLawStorage";
}

TramPowerLawStorage::~TramPowerLawStorage(void)
{
  delete [] mAlpha;  //; ήж٤ \alpha
  delete [] mM;      //; ήж٤ m
  delete [] mCqup;   //; üҤΨ
  delete [] mpSp;    //; ü
  delete [] mpRp;    //; ü
}

Boolean
TramPowerLawStorage::Init(char* o_name, int o_num)
{
  return Element::Init(o_name, o_num, 0, NULL);
}

Boolean
TramPowerLawStorage::Init(char* oname, int onum, FILE* fp)
{
  Object::Init(oname, onum);

  // read the number of receive ports from from fp
  if (fscanf(fp, "%d %d", &mNumRp, &mNumSp) != 2) {
    Eprint(__FILE__, __LINE__); exit(1);
  }

  if (mNumRp > 0) {
    mpRp = new Receive<double>[mNumRp];
    NEWCHECK(mpRp);
    mCqup = new double[mNumRp];
    NEWCHECK(mCqup);
  }

  if (mNumSp > 0) {
    mpSp = new Send<double>[mNumSp];
    NEWCHECK(mpSp);
    mAlpha = new double [mNumSp];
    NEWCHECK(mAlpha);
    mM = new int [mNumSp];
    NEWCHECK(mM);
  }

  for (int i = 0; i < mNumRp; i++) {
    mpRp[i].Init("rpdis", i);
    mCqup[i] = 1.0;
  }

  for (int i = 0; i < mNumSp; i++) {
    mpSp[i].Init("spdis", i);
    mAlpha[i] = 0.01;
    mM[i] = 2;
  }

  Set_parameter(fp);

  return YES;
}

//;  ֥Ȥεΰ
TramPowerLawStorage*
TramPowerLawStorage::NewElement()
{
  return new TramPowerLawStorage();
}

//;  üҡüҤ
void
TramPowerLawStorage::Register_send_ports(void)
{
  for (int i = 0; i < mNumSp; i++) {
    Register((void*)&(mpSp[i]));
  }
}

void
TramPowerLawStorage::Register_receive_ports(void)
{
  for (int i = 0; i < mNumRp; i++) {
    Register((void*)&(mpRp[i]));
  }
}

//;  ѥ᥿
void
TramPowerLawStorage::Set_parameter(FILE* fp)
{
  //; üҤΥǡ³Ψ
  for(int i = 0; i < mNumRp; i++) {
    int dct;
    if (fscanf(fp, "%d %lf", &dct, &mCqup[i]) != 2) {
      Eprint(__FILE__, __LINE__);
      Oprint();
      exit(1);
    }
    mpRp[i].Set_data_connection_type(dct);
  }

  //; ή O_i α s ȤδطηȻؿ
  for (int i = 0; i < mNumSp; i++) {
    if (fscanf(fp, "%lf %d", &mAlpha[i], &mM[i]) != 2) {
      Eprint(__FILE__, __LINE__);
      Oprint();
      exit(1);
    }
  }

  //; ̤ɸ (m^3) ȡͥ٥ (㤨С0.001)
  if (fscanf(fp, "%lf %lf", &mSlevel, &mEps) != 2) {
    Eprint(__FILE__, __LINE__);
    Oprint();
    exit(1);
  }
  mSsmall = mSlevel * mEps;

  fscanf(fp, "%d", &mFlag);  // monitor flag
  if (mFlag == 1) {
    char mfilename[128];
    mfilename[0] = '\0';
    char absname[128];
    Object::Absname(absname);
    strcat(mfilename, "monitor_storage");
    strcat(mfilename, absname);
    khmkdir(mfilename, 493); // create the directory mfilename
                             // with the mode 493 = 0755
    strcat(mfilename, "/monitor_storage.dat");
    monitor_storage.open(mfilename, ios::out);
    monitor_storage << "# monitor of " << absname << endl;
    mfilename[0] = '\0';

    strcat(mfilename, "monitor_deltaT");
    strcat(mfilename, absname);
    khmkdir(mfilename, 493); // create the directory mfilename
                             // with the mode 493 = 0755
    strcat(mfilename, "/monitor_deltaT.dat");
    monitor_deltaT.open(mfilename, ios::out);
    monitor_deltaT << "# monitor of " << absname << endl;
    mfilename[0] = '\0';
  }
}

//;  ̤
void
TramPowerLawStorage::Set_initial_state(FILE* fp)
{
  /*
  <li> time_t current_time: ߻ (unix time)
  <li> double mS_crnt:  (m^3)
  <li> int mHalvedp: η׻ (1) ³׻ (0)  (-)
  <li> mrPsum_last: 쥹ƥåʬ (m^3)
  <li> time_t mDt_next: ׻ֹߤθ (sec)
  <li> int mTime: ߤη׻ֳִ֤Ǥڤɾ򥯥ꥢϢ³
        (-)
  */
  if (fscanf(fp, "%ld %lf %d %lf %ld %d", &current_time,
    &mS_crnt, &mHalvedp, &mrPsum_last, &mDt_next, &mTime) != 6) {
    Eprint(__FILE__,__LINE__);Oprint();exit(1);
  }

  if (mS_crnt < 0.){
    Eprint(__FILE__,__LINE__);Oprint();exit(1);
  }
  if (mrPsum_last < 0.){
    Eprint(__FILE__,__LINE__);Oprint();exit(1);
  }
  if (mDt_next < 0.){
    Eprint(__FILE__,__LINE__);Oprint();exit(1);
  }

} // Set_initial_state

//;  Work
//; Can_you_calculate  Calculate ꤷƲ
Boolean
TramPowerLawStorage::Work(void)
{

//  if (current_time >= MediumTermTargetTime())
//  { return NO; }        //; ׻Ѥ

// 000904mk
  // <japanese>
  // ׻׵ʤcurrenet_time ɸۤƤз׻
  // 
  // </japanese>
  if (mCreqp == NO && current_time >= MediumTermTargetTime()) return NO;
// 000904mk

  //; ٤Ǥ׻¹Ԥ calc = YES Ȥʤ
  Boolean calc = NO;

 LOOP:	//; 롼 "LOOP" 

  //; ƥåפη׻.
  if (Calculate() == NO) {
    if (calc == NO) return NO;	//; ׻˽λ
    goto FINISH;
  }

  calc = YES;
  mCreqp = NO; // reset mCreqp

  //; ߻ (׻Ѥ߻) current_time ι.
  if (time_step <= 0) goto FINISH;
  current_time += time_step;
  if (current_time >= MediumTermTargetTime()) goto FINISH;

  goto LOOP;	//; ƥåפη׻.

  //; 롼 "LOOP" ޤ.

 FINISH:	//; ׻ν.

  Set_data_pack_array();	//; ǡѥåκ.
  Reduce_data_pack_stock();	//; ץǡѥåξõ.

  return YES;
}

//;  
Boolean
TramPowerLawStorage::Initial_output(void)
{
  double discharge;
  for (int i = 0; i < mNumSp; i++) {
    discharge = mAlpha[i] * pow(mS_crnt, mM[i]);
    mpSp[i].Set_comment_string("unix time (sec), discharge (m^3/sec)");
    mpSp[i].Send_data(current_time, discharge);
  }

  return YES;
}

//;  ǽ֤ե¸
void
TramPowerLawStorage::Save_terminal_state(FILE* fp)
{
  if (fp != NULL) {
    fprintf(fp, "%ld %f %d %f %ld %d", current_time, mS_crnt,
      mHalvedp, mrPsum_last, mDt_next, mTime);
  }
} // Save_terminal_state

//;  ꥭ졼
Boolean
TramPowerLawStorage::Calculate()
{
/*
 storage ˤĤ
   ü
     q_i = \alpha s_i$^m$
     frac{d s_i}{dt}
     = \Sigma^{m-1}_{j=0}a_i*I_i - \Sigma^{n-1}_{j=0}\alpha_j s$^m_j$
    tram ˡѤƲ

 ׻֤ȾʬˤȤϡδؿǺƷ׻ޤ׻֤2ܤˤ
 뤳ȤˤȤϡ2ܤˤ׻ߤǷ׻ΤϤĤ Caluculate 
 ƤФȤǤ

*/

  //; time_step : Υॹƥå
  //; mDt_next : δΥॹƥå
  //; dta : ॹƥåפκѿ
  time_step = Calculate_time_step();
  if (Can_you_calculate() == NO) { return NO; }

  long dta = time_step;

  if (mFlag == 1) {
    monitor_storage << current_time;
    monitor_deltaT << current_time;
  }

FIRST:

  //; rPsum: (t, t+dta) ֤γή (m^3)
  double rPsum = 0.;
  for (int i = 0; i < mNumRp; i++) {
    rPsum += mCqup[i] *
      mpRp[i].Get_mean_data(current_time,current_time+dta)  * dta;
  }

  mQ_crnt = 0.;
  for (int i = 0; i < mNumSp; i++) {
    mQ_crnt += mAlpha[i] * pow(mS_crnt, mM[i]);
  }
  if (mHalvedp == YES) {
    //; ׻ϻ⤷ϡ׻ֳִ֤Ⱦʬˤʤäľ
    //; AB-1 Eulerˡˤͽ¬
    double s_next = mS_crnt - dta * mQ_crnt + rPsum;

    //; α̤θ mS_crnt ٤礭Ǥ (mSlevel * mEps
    //; * 10.)⡢η׻ͤ 0.1 ܰʲΤȤϡѹ礭
    //; äΤǡ׻ֹߤȾʬˤޤ
    if ((mS_crnt > mSlevel * mEps * 10.) && (s_next < 0.1 * mS_crnt)) {
      if (dta > 1) {
        dta = dta/2;  mDt_next = dta;  goto FIRST;
      }
    }
    if (s_next < 0.) s_next = 0.;

    //; AB-2 Ūˤ뽤
    while (1) {
      mQ_next = 0.;
      for (int i = 0; i < mNumSp; i++) {
        mQ_next += mAlpha[i] * pow(s_next, mM[i]);
      }

      //; AB-2 Ūˤ뽤
      mS_next = mS_crnt + dta * (- mQ_next - mQ_crnt)/2. + rPsum;
      //; 礭ưä硢ʲξ֤ʤ dta Ⱦʬˤƺ
      //; ׻롣
      if ((mS_crnt > mSlevel * mEps * 10.) &&(mS_next < 0.1 * mS_crnt)) {
        if (dta > 1) {
          dta = dta/2;  mDt_next = dta;  goto FIRST;
        }
      }
      if (mS_next < 0.) mS_next = 0.;
      if (fabs(mS_next - s_next) < mSsmall) { break; }
      s_next = mS_next;
    }
    mHalvedp = NO;
  }
  else {                      //; ̾ξ
    //; AB-1 ˤͽ¬
    double
    s_next = mS_last - 2. * dta * mQ_crnt + rPsum + mrPsum_last;
    //; 礭ưä硢ʲξ֤ʤ dta Ⱦʬˤƺ
    //; ׻롣
    if ((mS_crnt > mSlevel * mEps * 10.) && (mS_next < 0.1 * mS_crnt)) {
      if (dta > 1) {
        dta = dta/2;  mDt_next = dta;  mHalvedp = YES;  goto FIRST;
      }
    }
    if (s_next < 0.) s_next = 0.;
    mQ_next = 0.;
    for (int i = 0; i < mNumSp; i++) {
      mQ_next += mAlpha[i] * pow(s_next, mM[i]);
    }

    //; AB-2 Ūˤ뽤
    mS_next = mS_crnt + dta * (- mQ_next - mQ_crnt)/2. + rPsum;

    //; 礭ưä硢ʲξ֤ʤ dta Ⱦʬˤƺ
    //; ׻롣
    if ((mS_crnt > mSlevel * mEps * 10.) && (mS_next < 0.1 * mS_crnt)) {
      if (dta > 1) {
        dta = dta/2;  mDt_next = dta;   mHalvedp = YES;  goto FIRST;
      }
    }
    if (mS_next < 0.) mS_next = 0.;

    //; Ǥڤ餫ꤷ mSmall 꾮 OK
    if (fabs(mS_next - s_next)/6. < mSsmall) {
      //; ̤ 1/6 ǤڤɾǤ롣쾾ֿͲϡס
      //; p.119
      mTime++;
      if (mTime == mTime_max) {
        //; ׻ֳִ֤ܤˤ
        if (dta < MaxDT) {
          mDt_next = dta * 2;  mTime = 0;  mDoubledp = YES;
        }
      }
    }
    else {
      if (dta > 1) {
        //; ׻ֳִ֤Ⱦʬˤ
        dta = dta/2;  mDt_next = dta;  mTime = 0;  mHalvedp = YES;
        goto FIRST;
      }
    }
  }

  //; 
  time_step = dta;
  double discharge_next;
  for (int i = 0; i < mNumSp; i++) {
    discharge_next = mAlpha[i] * pow(mS_next, mM[i]);
    mpSp[i].Send_data(current_time+time_step, discharge_next);
  }

  if (mFlag == 1) {
    monitor_storage << " " << mS_crnt << endl;
    monitor_deltaT << " " << time_step << endl;
  }

  //; ѿι
  if (mDoubledp == YES) {
    mrPsum_last += rPsum;  mDoubledp = NO;
  } else {
    mS_last = mS_crnt;  mrPsum_last = rPsum;
  }
  mS_crnt = mS_next;

  return YES;
}

/*; end of file */
