#! /usr/local/bin/perl
#
# @(#) print linearly interpolated values
#
# usage: $0 number startVal endVal
# "number" is the number of data to be generated by this program.
#
# $RCSfile$  $Revision$
# $Date$  by KyotoHydro
#

# argumets are $ARGV[0], $ARGV[1], ... $ARGV[$#ARGV]

sub usage {
   print "usage: $0 number startVal endVal\n";
   exit 1;
}

if ($#ARGV != 2) { &usage; }

$number = $ARGV[0];
$startVal = $ARGV[1];
$endVal = $ARGV[2];

$na = 1;
$nInLine = 5;    # $nInLine data at most are printed in one line.

while ($number >= $na) {
  $nb = $number;
  if ($na + $nInLine - 1 < $number) { $nb = $na + $nInLine - 1; }
  for ($i = $na; $i <= $nb; $i++) {
    $value = ($startVal*($number-$i) + $endVal*($i-1))/($number
    - 1);
    printf("%12.4f ", $value);
  }
  print "\n";
  $na = $nb + 1;
}

## Local Variables: ***
## mode: Text ***
## End: ***
